MODULE matmod
  IMPLICIT NONE
  PRIVATE
  PUBLIC :: readmat, spur, orth, posi

CONTAINS

  SUBROUTINE readmat(m)
     INTEGER, DIMENSION(:,:),INTENT(OUT):: m
     INTEGER:: i
	 READ(*,*) m !spaltenweise eingelesen
     DO i = 1, SIZE(m,1) !zeilenweise
      READ(*,*) m(i,:)
     END DO
  END SUBROUTINE readmat

  FUNCTION spur(m)
    INTEGER,DIMENSION(:,:), INTENT(IN):: m
    INTEGER:: spur, i
    spur = 0
    DO i = 1, SIZE(m,1) !SIZE(m,2)
      spur = spur + m(i,i)
    END DO
  END FUNCTION spur

  FUNCTION orth(m)
    INTEGER, DIMENSION(:,:),INTENT(IN):: m
    INTEGER, DIMENSION(SIZE(m,1),SIZE(m,2)):: e
    LOGICAL:: orth
    INTEGER:: i
    e = 0
    DO i = 1, SIZE(m,1)
      e(i,i) = 1
    END DO
    orth = ALL(MATMUL(m,TRANSPOSE(m))==e)
  END FUNCTION orth

  FUNCTION posi(m)
    INTEGER,DIMENSION(:,:), INTENT(IN):: M
    INTEGER,DIMENSION(SIZE(M,1),SIZE(M,2)):: posi
    INTEGER:: i, k
    !posi = m
    !DO i = 1, size(m,1)
    !  DO k = 1, size(m,2)
    !      IF(m(i,k)<0) THEN
    !        posi(i,k) = 0
    !      END IF
    !  END DO
    !END DO
    posi = max(0,M)
  END FUNCTION

END MODULE matmod

PROGRAM mat
  USE matmod
  IMPLICIT NONE

  INTEGER:: dimen, i
  INTEGER, DIMENSION(:,:), ALLOCATABLE:: matrix, posm

  WRITE(*,*) 'Please enter dimension:'
  READ(*,*) dimen

  ALLOCATE(matrix(dimen,dimen), posm(dimen,dimen))

  WRITE(*,*) 'Please enter matrix:'
  CALL readmat(matrix)

  WRITE(*,*) 'Spur or sum of the diagonal:', spur(matrix)
  WRITE(*,*) 'Matrix is orthogonal:', orth(matrix)

  WRITE(*,*) 'Positive part of the matrix:'

  posm = posi(matrix)

  DO i = 1, dimen
    WRITE(*,*) posm(i,:)
  END DO

  DEALLOCATE(matrix, posm)
END PROGRAM mat
